/************************************************************************************
*                                                                                   *
*   File Name   : funcs.h                                                           *
*   Contents    : Includes                                                          *
*   Version     : 1.10                                                               *
*************************************************************************************/
/* defines */
#define cMaxWaitCycles 100
#define cPULSES_PER_0_01KWH 8
#define cPULSES_PER_0_00001M3 3
#define cEC_PORT p1_2
#define cGC_PORT p1_1
#define cWC_PORT p1_0
#define c1S_TICK_PORT p1_3
#define cEC_SENS_PORT p4_5
#define cGC_SENS_PORT p1_7
#define cWC_SENS_PORT p3_2
#define cConsecutiveEventsElecTime  10 /* 100 ms */
#define cDebounceTimeElec            3 /*  30 ms */
#define cConsecutiveEventsGasTime   10 /* 100 ms */
//#define cDebounceTimeGas            10 /* 100 ms correct */
#define cDebounceTimeGas             3 /* 100 ms wrong */
//#define cConsecutiveEventsWaterTime  7 /*  70 ms correct */
//#define cDebounceTimeWater           7 /*  70 ms correct */
#define cConsecutiveEventsWaterTime 10 /*  70 ms wrong */
#define cDebounceTimeWater           3 /*  70 ms wrong */
/* typedef's */
typedef union
{
	struct
	{
		unsigned char rs232_rcv_data;
		unsigned char rs232_rcv_flags;
	} byte;
	unsigned int word;
}  rs232_rcv_type;		 
/* function prototypes from timer_x.c */
void TIMERX_init(void);
/* function prototypes from uart.c */
void sendTxd0(unsigned char data);
void sendConsumptionValues(unsigned long electricalConsumption, unsigned long gasConsumption, unsigned long waterConsumption);
void UART0_init(void);
/* function prototypes from extints.c */
void EXTINTS_init(void);
/* function prototypes from main.c */
void toggle_lower3leds (void);
/* global RAM */
extern unsigned int ui_TIRQ_count10ms;
extern _Bool         b_VERSIONsendREQ;

extern unsigned int  ui_EC_EIRQ_timestamp;
extern unsigned long ul_ML_electricalConsumption; 
extern unsigned char uc_ML_pulsesElPow;
extern unsigned char uc_EC_TIRQ_validEvent;
extern unsigned char uc_EC_ML_validEvent;
extern unsigned int  ui_EC_TIRQ_timestamp;
extern unsigned int  ui_EC_TIRQ_debounceCounter;

extern unsigned int  ui_GC_EIRQ_timestamp;
extern unsigned long ul_ML_gasConsumption; 
extern unsigned char uc_GC_TIRQ_validEvent;
extern unsigned char uc_GC_ML_validEvent;
extern unsigned int  ui_GC_TIRQ_timestamp;
extern unsigned int  ui_GC_TIRQ_debounceCounter;

extern unsigned int  ui_WC_EIRQ_timestamp;
extern unsigned long ul_ML_waterConsumption;
extern unsigned char uc_WC_TIRQ_validEvent;
extern unsigned char uc_WC_ML_validEvent;
extern unsigned int  ui_WC_TIRQ_timestamp;
extern unsigned int  ui_WC_TIRQ_debounceCounter;

extern rs232_rcv_type rs232_rcv;
extern unsigned char rs232_rcv_array[36];
extern unsigned char startIndicator;
extern unsigned char positionPointer;

extern unsigned char ini_rcvd_yet; 
